<template>
  <basic-container>
    <avue-crud :option="option"
               :table-loading="loading"
               :data="data"
               :page.sync="page"
               :permission="permissionList"
               :before-open="beforeOpen"
               v-model="form"
               ref="crud"
               @row-update="rowUpdate"
               @row-save="rowSave"
               @row-del="rowDel"
               @search-change="searchChange"
               @search-reset="searchReset"
               @selection-change="selectionChange"
               @current-change="currentChange"
               @size-change="sizeChange"
               @refresh-change="refreshChange"
               @on-load="onLoad">
      <template slot="menuLeft">
        <el-button type="danger"
                   size="small"
                   icon="el-icon-delete"
                   plain
                   v-if="permission.serveruser_delete"
                   @click="handleDelete">删 除
        </el-button>
      </template>
      <template slot="residentialId" slot-scope="scope">
        <div>{{scope.row.residentialName}}</div>
      </template>
    </avue-crud>
  </basic-container>
</template>

<script>
  import {getList, getDetail, add, update, remove} from "@/api/person/serveruser";
  import {mapGetters} from "vuex";

  export default {
    data() {
      return {
        form: {},
        query: {},
        loading: true,
        page: {
          pageSize: 10,
          currentPage: 1,
          total: 0
        },
        selectionList: [],
        option: {
          height:'auto',
          calcHeight: 30,
          tip: false,
          searchShow: true,
          searchMenuSpan: 6,
          border: true,
          index: true,
          viewBtn: true,
          selection: true,
          dialogClickModal: false,
          column: [
            {
              label: "姓名",
              prop: "name",
              rules: [{
                required: true,
                message: "请输入姓名",
                trigger: "blur"
              }]
            },
            {
              label: "性别",
              prop: "sex",
              type:'select',
              dicUrl: "/api/blade-system/dict-biz/dictionary?code=sex",
              props: {
                label: "dictValue",
                value: "dictKey"
              },
              dataType:'number',
              rules: [{
                required: true,
                message: "请选择性别",
                trigger: "blur"
              }]
            },
            {
              label: "省",
              prop: "regionProvince",
              type: "select",
              dicUrl: "/api/blade-system/region/lazy-tree?parentCode=000000",
              cascaderItem:["regionCity"],
              props:{
                label:"title",
                value: "id"
              },
              value: "null",
              rules: [{
                required: true,
                message: "请输入省",
                trigger: "blur"
              }]
            },
            {
              label: "市",
              prop: "regionCity",
              type: "select",
              width: 100,
              cascaderItem: ["regionArea"],
              dicUrl: `/api/blade-system/region/lazy-tree?parentCode={{key}}`,
              props:{
                label: "title",
                value: "id"
              },
              rules: [{
                required: true,
                message: "请输入市",
                trigger: "blur"
              }]
            },
            {
              label: "区",
              prop: "regionArea",
              type: "select",
              cascaderItem: ["residentialId"],
              dicUrl: `/api/blade-system/region/lazy-tree?parentCode={{key}}`,
              props:{
                label: "title",
                value: "id"
              },
              rules: [{
                required: true,
                message: "请输入区",
                trigger: "blur"
              }]
            },
            {
              label: "籍贯",
              prop: "birthPlace",
              rules: [{
                required: true,
                message: "请输入籍贯",
                trigger: "blur"
              }]
            },
            {
              label: "所属小区",
              prop: "residentialId",
              type: "select",
              search: true,
              slot:true,
              // searchFilterable: true,
              // dicUrl: "/api/cyzh-community/residential/list?regionArea={{key}}",
              dicUrl: "/api/cyzh-community/residential/list?size=99999",
              dicFormatter:(res)=>{
                return res.data.records;//返回字典的层级结构
              },
              props: {
                label: "name",
                value: "id"
              },
              filterable: true,
              rules: [{
                required: true,
                message: "请输入所属小区",
                trigger: "blur"
              }]
            },
            // {
            //   label: "所属小区名称",
            //   prop: "residentialName",
            //   rules: [{
            //     required: true,
            //     message: "请输入所属小区名称",
            //     trigger: "blur"
            //   }]
            // },
            {
              label: "人员类型",
              prop: "type",
              type:'select',
              dicUrl:'/api/blade-system/dict-biz/dictionary?code=service_people_type',
              props: {
                label: "dictValue",
                value: "dictKey"
              },
              dataType:'number',
              rules: [{
                required: true,
                message: "请输入人员类型",
                trigger: "blur"
              }]
            },
            {
              label: "联系电话",
              prop: "tel",
              rules: [{
                required: true,
                message: "请输入联系电话",
                trigger: "blur"
              }]
            },
            {
              label: "身份证",
              prop: "idCard",
              hide:true,
              rules: [{
                required: true,
                message: "请输入身份证",
                trigger: "blur"
              }]
            },
            {
              label: "备注",
              prop: "remark",
              rules: [{
                required: true,
                message: "请输入备注",
                trigger: "blur"
              }]
            },
            {
              label: "是否启用",
              prop: "isEnable",
              type:'select',
              dicUrl: "/api/blade-system/dict-biz/dictionary?code=on_off",
              props: {
                label: "dictValue",
                value: "dictKey"
              },
              dataType:'number',
              rules: [{
                required: true,
                message: "请输入0-启用  1-禁用",
                trigger: "blur"
              }]
            },
            {
              label: "人脸启用状态",
              prop: "faceEnable",
              type:'select',
              dicUrl: "/api/blade-system/dict-biz/dictionary?code=face_enable",
              props: {
                label: "dictValue",
                value: "dictKey"
              },
              dataType:'number',
              rules: [{
                required: true,
                message: "请输入人脸启用状态：0-待启用 1-已启动 2-已禁用",
                trigger: "blur"
              }]
            },
            {
              label: "人脸图片",
              prop: "imageUri",
              type:'upload',
              listType: 'picture-img',
              propsHttp: {
                res: "data",
                url: "link"
              },
              tip: '只能生产jpg/png图片，且不超过500kb',
              action: "/api/blade-resource/oss/endpoint/put-file",
              rules: [{
                required: true,
                message: "请输入人脸图片",
                trigger: "blur"
              }]
            },
            {
              label: "人脸有效开始时间",
              prop: "beginDate",
              type:'datetime',
              hide:true,
              rules: [{
                required: true,
                message: "请输入人脸有效开始时间·",
                trigger: "blur"
              }]
            },
            {
              label: "人脸有效截止时间",
              prop: "endDate",
              type:'datetime',
              hide:true,
              rules: [{
                required: true,
                message: "请输入人脸有效截止时间",
                trigger: "blur"
              }]
            },
          ]
        },
        data: []
      };
    },
    computed: {
      ...mapGetters(["permission"]),
      permissionList() {
        return {
          addBtn: this.vaildData(this.permission.serveruser_add, false),
          viewBtn: this.vaildData(this.permission.serveruser_view, false),
          delBtn: this.vaildData(this.permission.serveruser_delete, false),
          editBtn: this.vaildData(this.permission.serveruser_edit, false)
        };
      },
      ids() {
        let ids = [];
        this.selectionList.forEach(ele => {
          ids.push(ele.id);
        });
        return ids.join(",");
      }
    },
    methods: {
      rowSave(row, done, loading) {
        add(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          window.console.log(error);
        });
      },
      rowUpdate(row, index, done, loading) {
        update(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          console.log(error);
        });
      },
      rowDel(row) {
        this.$confirm("确定将选择数据删除?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(row.id);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
          });
      },
      handleDelete() {
        if (this.selectionList.length === 0) {
          this.$message.warning("请选择至少一条数据");
          return;
        }
        this.$confirm("确定将选择数据删除?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(this.ids);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
            this.$refs.crud.toggleSelection();
          });
      },
      beforeOpen(done, type) {
        if (["edit", "view"].includes(type)) {
          getDetail(this.form.id).then(res => {
            this.form = res.data.data;
          });
        }
        done();
      },
      searchReset() {
        this.query = {};
        this.onLoad(this.page);
      },
      searchChange(params, done) {
        this.query = params;
        this.page.currentPage = 1;
        this.onLoad(this.page, params);
        done();
      },
      selectionChange(list) {
        this.selectionList = list;
      },
      selectionClear() {
        this.selectionList = [];
        this.$refs.crud.toggleSelection();
      },
      currentChange(currentPage){
        this.page.currentPage = currentPage;
      },
      sizeChange(pageSize){
        this.page.pageSize = pageSize;
      },
      refreshChange() {
        this.onLoad(this.page, this.query);
      },
      onLoad(page, params = {}) {
        this.loading = true;
        getList(page.currentPage, page.pageSize, Object.assign(params, this.query)).then(res => {
          const data = res.data.data;
          this.page.total = data.total;
          this.data = data.records;
          this.loading = false;
          this.selectionClear();
        });
      }
    }
  };
</script>

<style>
</style>
